/*
 * Chutes and Ladders program for sockets
 */

/*
 * File         : ChutesandLadders.java
 * Author       : Hilda Medina
 * Created      : Dec 10, 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/12/08 18:47:19 $
 * Copyright    : Northeast Parallel Architectures Center
 *                at Syracuse University 1998
 */

import java.applet.Applet;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;


//import webwisdom.tango.*;


public class ChutesandLadders extends Applet
implements Runnable{


  private Socket connection; 
  private DataInputStream input; 
  private DataOutputStream output; 
  private Thread outputThread; 
  
  //implements TDataListener, TControlListener {		 
  int Number_of_players=2;     
  int Max = 10;
  int Max_Number_of_players = 2;/* max players number */
  int maxboard = 101;
  int Die_size = 50;
  int current = -1, hit = -1, current_board = -1, hit_board = -1;
  int hit_boarda, current_boarda;
  int xofs = 0, yofs = 0;
  int xs = 50;
  int ys = 500;  
  int board_size = 50;
  int boardl = board_size/5;
  int player_size = 17;  
  int oldx = -1, oldy = -1, oldboard = -1, oldboarda;
  int die= 0;
  int playert;
  int maxc = 22;
  int chutes_ladders[] = new int[maxc];
  int goto_chutes_ladders[]= new int[maxc];
  boolean next_message=true;
  int message_type=0;
  boolean win=false;
  Font f = new Font("TimesRoman",Font.BOLD,18);
  boolean in_a_ladder = false;
  mCircle player[];
  mRectangle board[];
  mDie Die;
  boolean CANMOVE= true; 
  int I_AM_PLAYER=0; // the master will not change this, so master = player 0
  
  //The image:
  private Image image;
  
  //char name[] = new char[Number_of_players];
  boolean AM_I_MASTER; 
  
  int DIE_SEND = -1;                                            
  int PLAYER_SEND = -2;                                         
  int LOC_SEND = -3;                                            
  int WIN_SEND = -4;                                                            
  int SOUND_SEND = -5;
  int NUM_PLAYERS_INC = -6;
  int NUM_PLAYERS_T= -7;
  int NAME = -8;                                          
  int player_won= -9;  
  int TOTAL_PLAYERS_SEND= -10;
  int NUM_PLAYERS_DEC = -11;
  //int WAIT_FOR_ANOTHER_PLAYER = -12;

  static int WAITING = -13;
  static int BOTH_CONNECTED = -14;


  //TAgent agent=null;                                             
  //for the chutes and ladders:                                 
  int jumps = 10;                                               
  //------------------------------------------------------------
  public void send(int _message) {
    System.out.println("ready to send out "+_message);
    try{
		System.out.println("outputing message");
      output.writeInt(_message);
    }   
    catch ( IOException ie ) { 
		System.out.println("ie.printstackstrace");
      ie.printStackTrace();          
    } 
  } 
  
  public void init() {
    
	 //TANGO: REGISTER, ADD LISTENER----------------------------------
//     try                                                           
//       {                                                         
// 	agent=new TAgent(new TLAgentApplet(this));            
// 	agent.addTDataListener(this);                         
// 	agent.addTControlListener(this);
// 	AM_I_MASTER =  agent.isMaster();                      								
// 	//   
//       }                                                         
//     catch(TangoException e)                                       
//       {                                                         
// 	e.printStackTrace();                                  
//       }            

    System.out.println("in init");
    int iplayer=0;

    System.out.println("done init0");
	 //    outputThread = new Thread( this ); 
    //outputThread.start();
//     try {
//       iplayer = input.readInt();
//       System.out.println("I am player " + iplayer);
//     }
//     catch ( IOException e ) { 
//       e.printStackTrace();          
//     } 



    AM_I_MASTER = false;
    if (iplayer == 0) AM_I_MASTER = true; 
    
    if (iplayer == 0) System.out.println("I AM the master");
    
    setBackground(Color.white);
    setForeground(Color.black);
    System.out.println("Still in init");
				//Image:
    image = getImage(getDocumentBase(), "chutes_ladders.gif"); 
    
				// so now we will create the board
    int board_start = 0;
    
    board = new mRectangle[maxboard];
    int l = 0;
    for (int j=0;j<10;j++) {
      for (int i=1;i<11;i++) {
	l++;
	if ( j%2 == 0) {
	  board[l] = new mRectangle(xs + (i-1)*board_size,ys - j*board_size,
				    board_size,board_size,0,l);
	  //board[l].setColor(Color.pink);
	}else {
	  board[l] = new mRectangle(xs + (i-1)*board_size,ys - j*board_size,
				    board_size,board_size,0,(10*(j+1)-i+1));
	  //board[l].setColor(Color.blue);
	}
      }
    }
    l = 0;
    board[l] = new mRectangle(xs  - board_size,ys,board_size,board_size,9,0);
    board[l].setColor(Color.blue);	
    
				//Players:
    player = new mCircle[Max];
    
				//The players:
    
    player[0] = new mCircle(board[board_start].x+boardl,board[board_start].y+boardl ,
			    player_size, player_size,0,board_start);
    player[0].setColor(Color.blue);
    
    player[1] = new mCircle(board[board_start].x+3*boardl,board[board_start].y+boardl ,
			    player_size, player_size,1,board_start);
    player[1].setColor(Color.red);
    
    player[2] = new mCircle(board[board_start].x+boardl,board[board_start].y+3*boardl ,
			    player_size, player_size,2,board_start);
    player[2].setColor(Color.black);
    
    player[3] = new mCircle(board[board_start].x+3*boardl,board[board_start].y+3*boardl ,
			    player_size, player_size,3,board_start);
    player[3].setColor(Color.green);
    
	 //---------------------------------------------------------------- Comment for now
	 //     if ((AM_I_MASTER==false ) && Number_of_players < Max_Number_of_players ) {
	 //       Number_of_players = Number_of_players + 1;
	 //       send(NUM_PLAYERS_INC);//agent.send(stringToBytes( String.valueOf(NUM_PLAYERS_INC)));        
	 //       send(Number_of_players);//agent.send(stringToBytes( String.valueOf(Number_of_players)));      
	 //       I_AM_PLAYER = -100;
	 //     } else if (AM_I_MASTER == false) { 
	 //       CANMOVE = false;
	 //       //	for (int i1=0;i1<100;i1++) {System.out.println("CANMOVE = false");}
	 //     }                  
    //----------------------------------------------------------------------
    System.out.println("setting up the chutes and ladders");
				//The chutes:
    chutes_ladders[1] = 98;
    goto_chutes_ladders[1] = 78;
    
    chutes_ladders[2] = 95;
    goto_chutes_ladders[2] = 75;
    
    chutes_ladders[3] = 93;
    goto_chutes_ladders[3] = 73;
    
    chutes_ladders[4] = 87;
    goto_chutes_ladders[4] = 24;
    
    chutes_ladders[5] = 64;
    goto_chutes_ladders[5] = 60;
    
    chutes_ladders[6] = 62;
    goto_chutes_ladders[6] = 19;
    
    chutes_ladders[7] = 56;
    goto_chutes_ladders[7] = 53;
    
    chutes_ladders[8] = 49;
    goto_chutes_ladders[8] = 11;
    
    chutes_ladders[9] = 47;
    goto_chutes_ladders[9] = 26;
    
    chutes_ladders[10] = 16;
    goto_chutes_ladders[10] = 6;
    
    //The ladders:
    chutes_ladders[11] = 80;
    goto_chutes_ladders[11] = 100;
    
    chutes_ladders[12] = 71;
    goto_chutes_ladders[12] = 91;
    
    chutes_ladders[13] = 51;
    goto_chutes_ladders[13] = 67;
    
    chutes_ladders[14] = 36;
    goto_chutes_ladders[14] = 44;
    
    chutes_ladders[15] = 28;
    goto_chutes_ladders[15] = 84;
    
    chutes_ladders[16] = 21;
    goto_chutes_ladders[16] = 42;
    
    chutes_ladders[17] = 9;
    goto_chutes_ladders[17] = 31;
    
    chutes_ladders[18] = 4;
    goto_chutes_ladders[18] = 14;
    
    chutes_ladders[19] = 1;
    goto_chutes_ladders[19] = 38;
    
    playert = 0;  
    repaint();
 	 //System.out.println("starting a thread");
	 //outputThread = new Thread( this ); 
	 //outputThread.start();
 	 //System.out.println("done the start thread");
    //System.out.println("ready to send out the dice");
    Die = new mDie(2, 2, Die_size-1, Die_size-1);
    Die.setColor(Color.black);  
    die = 1 + (int) ( Math.random() * 6 ); 
    
    //TANGO-----------------------------------------------------------------
    //if (AM_I_MASTER==false && CANMOVE == true ) {
	 //send(DIE_SEND);//agent.send(stringToBytes( String.valueOf(DIE_SEND)));               
	 //send(die);//agent.send(stringToBytes( String.valueOf(die)));                    
    //}
    /*TANGO-----------------------------------------------------------------*/
  }
  // the run method

   public void start() {
    System.out.println("in start");
    try {
      connection =
  new Socket( InetAddress.getLocalHost(), 4444 );
      input = new DataInputStream(
          connection.getInputStream() );
      output = new DataOutputStream(
            connection.getOutputStream() );
    }
    catch ( IOException e ) {
      e.printStackTrace();
    }
       
    outputThread = new Thread( this );
    outputThread.start();
  }

  public void run() {
    System.out.println("in run");
	 //     try { 
	 //       myMark = input.readInt(); 
	 //     } 
	 //     catch ( IOException e ) { 
	 //       e.printStackTrace();          
	 //     } 
    //Receive messages sent to client 
	 int iplayer;
    try {
      iplayer = input.readInt();
      System.out.println("GOT MESSAGE:-------->     I am player " + iplayer);
	 }
	 catch ( IOException e ) { 
      e.printStackTrace();          
    } 
	 while ( true ) { 
		System.out.println("In the while loop of run");
		try { 
		  System.out.println("ready for the sint=input");
		  int sint = input.readInt(); 
		  System.out.println("ready to call processMessage from run "+ sint );
		  receive( sint ); 
		} 
		catch ( IOException e ) { 
		  System.out.println("in the pritnstack"); 
		  e.printStackTrace();          
		} 
	 } 
  } 
  
  /* this method will be called to respond a disclosure */
  public void paint(Graphics g) {				/* we want to redraw the whole client area */
	 /* draw boundry */
    if (win == true) {
      g.setFont(f);
      if (player_won == 0) {g.setPaintMode();
      g.setColor(Color.blue);
      g.drawString("Blue has just won!",100,30);	
      Die.paint(g);
      } else if (player_won == 1) {
	g.setColor(Color.red);
	g.drawString("Red has just won!",100,30);
	Die.paint(g);
      } else if (player_won == 2) {
	g.setColor(Color.black);
	g.drawString("Black has just won!",100,30);	
	Die.paint(g);
      } else if (player_won == 3) {
	g.setColor(Color.green);
	g.drawString("Green has just won!",100,30);	
	Die.paint(g);
      }		stop();		
    }
    g.setColor(getForeground());
    Die.paint(g);	
    g.setColor(getForeground());
    g.drawRect(0, 0, size().width-1, size().height-1);
    g.drawImage(image, 50, 50, this);		
				/* draw objects */
    //if (AM_I_MASTER == true) {
	 //send(TOTAL_PLAYERS_SEND );//agent.send(stringToBytes( String.valueOf(TOTAL_PLAYERS_SEND)));               
	 //send(Number_of_players);//agent.send(stringToBytes( String.valueOf(Number_of_players)));  
    //}
    int nop = Number_of_players;
    if (nop >= Max_Number_of_players) nop = Max_Number_of_players - 1;
    for (int i=0; i<=nop; i++) player[i].paint(g);
    
				//if (win == true	&& playert == 0) playert = Number_of_players;
				//if (win == true && playert != 0) playert = playert-1; 
    if (win == true) {
      Die.Number(g, die,player_won);
      g.setColor(getForeground());
    }
    Die.Number(g, die,playert);
    g.setColor(getForeground());	
    Die.paint(g);			
    
				/* user who call getGraphics should call dispose */ 			 
				//g.dispose();
  }
  public void drawBoundry() {
    Graphics g = getGraphics();
				/* draw boundry */
    g.setColor(getForeground());
    g.drawRect(0, 0, size().width-1, size().height-1);
    g.dispose();
  }
  
  
  //------------------------------------------------------------------------------------
  //                                                                                  \ /
  
  /* Mouse Move Event */
  public boolean mouseMove(Event ev, int x, int y) {
    
    int i;
    hit = -1;
    hit_board = -1;
    hit_boarda = -1;
    Graphics g = getGraphics();
    g.setXORMode(Color.cyan);
				//g.setPaintMode();
    if ( ( playert == 0 && AM_I_MASTER == true ) ||
	 ( playert != 0 && AM_I_MASTER == false) && win == false && CANMOVE == true) {
      
      for (i=0; i<=Number_of_players; i++) {
	if ( playert == I_AM_PLAYER && player[i].isInside( x, y ) && 
	     player[i].col == playert && win == false ) {
	  hit = i;
	  break;
	}
      }
      for (i=0;i<maxboard;i++) {
	if ( board[i].isInside( x, y ) ) {
	  hit_board = i;
	  hit_boarda = board[i].actual_board_location;
	  
	  break;
	}
      }
      player[0].setColor(g,Color.blue);
      //if (Number_of_players == 1) {
      player[1].setColor(g,Color.red);
      //}
      //if (Number_of_players == 2) {
      player[2].setColor(g,Color.black);
      //}
      //if (Number_of_players==3) {
      player[3].setColor(g,Color.green);
      //}
    }
    g.dispose();				
    return true;
  }
  
  /* Mouse Down Event */
  public boolean mouseDown(Event ev, int x, int y) {
    
    current = hit;
    current_board = hit_board;
    current_boarda = hit_boarda;
    if ( current != -1 ) {
      xofs = player[current].x-x;
      yofs = player[current].y-y;
      oldx = player[current].x;
      oldy = player[current].y;
      oldboard = player[current].location;
      
    }
    return true;
  }
  /* Mouse Drag Event */
  public boolean mouseDrag(Event ev, int x, int y) {
    if ( current != -1 ) {
      Graphics g = getGraphics();
      //g.setPaintMode();
      g.setXORMode(Color.cyan);
      player[current].moveTo(g, x+xofs, y+yofs);
      g.dispose();
    }
    return true;
  }
  
  public int find_boardto(int board_toa) {
				// given board_toa, make the return be equal to the board 
    if (board_toa <=20 && board_toa>10) 	return(11 + 20 - board_toa);
    if (board_toa <=40 && board_toa>30) 	return(31 + 40 - board_toa);
    if (board_toa <=60 && board_toa>50) 	return(51 + 60 - board_toa);
    if (board_toa <=80 && board_toa>70) 	return(71 + 80 - board_toa);
    if (board_toa <=100 && board_toa>90) 	return(91 + 100 - board_toa);
    return(board_toa);
  }
  
  /*TANGO---------------------------------------------------------------------*/
  public void receive(int b) {           
				// update location of current player with b;                               
    int location = 0;                                                         
    String loc ;                                                            
    Integer loc9;                                                           
    Graphics g;                                                             
				//
    //loc = bytesToString(b);	
    //loc9 = Integer.valueOf(loc);                                   
    location = b;//loc9.intValue();  

    
    if (next_message == false) {                                            
      next_message = true;                                   
      if (message_type == DIE_SEND) {                                      
	die = location;    
	repaint();                                                      
      } else if (message_type ==PLAYER_SEND) {                             
	playert = location;                                             
	repaint();                                                      
      } else if (message_type == LOC_SEND) {                              
	g = getGraphics();                                              
	g.setPaintMode();                                               
	/*g.setXORMode(Color.black);*/                                  
	player[playert].location = location; //find_boardto(location);  
	current = playert;                                              
	int board_to = location;                                            
	player[current].setColor(g,Color.cyan);                         
	if (player[current].col == 0) {     
	  player[current].x = board[board_to].x + boardl;          
	  player[current].y = board[board_to].y + boardl;          
	  player[current].setColor(g,Color.blue);                  
	} else if (player[current].col == 1) {                          
	  player[current].x = board[board_to].x + 3*boardl;        
	  player[current].y = board[board_to].y + boardl;          
	  player[current].setColor(g,Color.red);                   
	} else if (player[current].col == 2) {				                  
	  player[current].x = board[board_to].x + boardl;             
	  player[current].y = board[board_to].y + 3*boardl;           
	  player[current].setColor(g,Color.black);                    
	} else if (player[current].col == 3) {                          
	  player[current].x = board[board_to].x + 3*boardl;           
	  player[current].y = board[board_to].y + 3*boardl;           
	  player[current].setColor(g,Color.green);                    
	}                                                               
	board[board_to].which_players+=player[current].col;             
	repaint();                                                      
      } else if (message_type == WIN_SEND) {                              
	win=true;                                                       
	player_won = location;                                          
	repaint();                                                      
      } else if(message_type == SOUND_SEND) {                             
	if (location == 1) {                                             
	  play(getCodeBase(), "yahoo1.au");                           
	} else play(getCodeBase(), "hurts.au");                        
      } else if (message_type == TOTAL_PLAYERS_SEND) {
	Number_of_players = location;
	if (I_AM_PLAYER == -100) {
	  I_AM_PLAYER = Number_of_players;
	}
	if (I_AM_PLAYER == Max_Number_of_players) {
	  System.out.println("Too bad.... you can't play!!!");
	  g = getGraphics();    
	  g.setFont(f);
	  g.setPaintMode();
	  g.setColor(Color.black);
	  g.drawString("Sorry, but you can only  watch",100,30);
	  CANMOVE = false;
	  send(NUM_PLAYERS_DEC);//agent.send(stringToBytes( String.valueOf(NUM_PLAYERS_DEC)));        
	  send(Number_of_players);//agent.send(stringToBytes( String.valueOf(Number_of_players)));
	  I_AM_PLAYER = -999;
	} else {
	  repaint();
	}
      }else if(message_type == NUM_PLAYERS_INC ) {                        
	if (location != Number_of_players+1) {
	}
	Number_of_players++;	
	
						 
	repaint();
      } else if (message_type == NUM_PLAYERS_DEC ) {
	Number_of_players--;
	
      }	else if(message_type ==  NUM_PLAYERS_T) {                         
	Number_of_players = location;	
      }else if(message_type ==  NAME ) { 
	player[Number_of_players].setName(location);	
      } else    
	System.out.println("ERROR "+location+ " " + message_type);            
    } else if (message_type == WAITING) {
      System.out.println("Waiting for another player");
    }else {                                                                 
      next_message = false;	                                            
      message_type = location;                                            
    }  
  }                                                                           
  /*--------------------------------------------------------------------------*/
  private String bytesToString(byte t[])
    {
      return new String(t,0);
    }
  
  private byte[] stringToBytes(String s)
    {
      int l=s.length();
      byte[] t=new byte[l];
      s.getBytes(0,l,t,0);
      return t;
    } 
  
  
  /* Mouse Up Event */
  public boolean mouseUp(Event ev, int x, int y) {
    
				// am I allowed to move in this location?????
				// first thing is if I am in a board location????
    int board_to = -1, board_toa=-1;
    int i;
    Graphics g = getGraphics();
				//g.setXORMode(Color.);
    g.setPaintMode();
    for (i=0;i<maxboard;i++) {
      if (board[i].isInside(x,y)) {
	board_to = i;
	board_toa = board[i].actual_board_location;
	// tango communicate board_to
	break;
      }
    }
    
    
    int board_from = hit_board;
    int board_froma = hit_boarda;
    if (current == 0 || current == 1 || current == 2 || current == 3) {
      repaint();
      if (board_to != -1 && (board_toa - board_froma ==die)) {
	player[current].setColor(g,Color.cyan);
	for (i=1;i<maxc;i++) {
	  //Animation here
	  
	  if (board_toa == chutes_ladders[i]) {
	    board_toa = goto_chutes_ladders[i];
	    //The ladders:
	    if (i >10) {
	      in_a_ladder = true;
	      play(getCodeBase(), "yahoo1.au");
	      send(SOUND_SEND);//agent.send(stringToBytes( String.valueOf(SOUND_SEND)));		
	      send(1);//agent.send(stringToBytes( String.valueOf(1) ) );
	    } else {//the chutes:
	      play(getCodeBase(), "hurts.au");
	      send(SOUND_SEND);//agent.send(stringToBytes( String.valueOf(SOUND_SEND)));		
	      send(-1);//agent.send(stringToBytes( String.valueOf(-1) ) );
	    }
	    board_to = find_boardto(board_toa);
	  }
	}
	send(LOC_SEND);//agent.send(stringToBytes( String.valueOf(LOC_SEND)));		
	send(board_to);//agent.send(stringToBytes( String.valueOf(board_to) ) );																
	int px=0, py=0;
	if (current==0) {px=1;py=1;}
	if (current==1) {px=3;py=1;}
	if (current==2) {px=1;py=3;}
	if (current==3) {px=3;py=3;}
	if( in_a_ladder == true ) {									
	  int x1 =player[current].x;
	  int x2 =board[board_to].x + px*boardl;
	  int y1 =player[current].y;
	  int y2=board[board_to].y+py*boardl;
	  int dx =(x2-x1)/(jumps-1);
	  int m = (y2-y1)/(x2-x1);
	  int xn,yn;
	  for (i=0;i<jumps;i++) {
	    xn = x1 + dx * i;
	    yn = m*xn + (y1 - x1*m);
	    player[current].setColor(g,Color.cyan);
	    player[current].x = xn;
	    player[current].y = yn;
	    if (player[current].col==0) player[current].setColor(g,Color.blue);
	    if (player[current].col==1) player[current].setColor(g,Color.red);
	    if (player[current].col==2) player[current].setColor(g,Color.black);
	    if (player[current].col==3) player[current].setColor(g,Color.green);
	    //wait 1000 miliseconds before repaint again:
	    repaint(1000);
	    //in order to put the player in the correct position:
	    if (i == jumps - 1) {
	      player[current].setColor(g,Color.cyan);		 
	      player[current].x = board[board_to].x + px*boardl;
	      player[current].y = board[board_to].y + py*boardl;
	      if (player[current].col==0) player[current].setColor(g,Color.blue);
	      if (player[current].col==1) player[current].setColor(g,Color.red);
	      if (player[current].col==2) player[current].setColor(g,Color.black);
	      if (player[current].col==3) player[current].setColor(g,Color.green);
	    }
	  }													 
	}
	else {
	  player[current].setColor(g,Color.cyan);		 
	  player[current].x = board[board_to].x + px*boardl;
	  player[current].y = board[board_to].y + py*boardl;
	  if (player[current].col==0) player[current].setColor(g,Color.blue);
	  if (player[current].col==1) player[current].setColor(g,Color.red);
	  if (player[current].col==2) player[current].setColor(g,Color.black);
	  if (player[current].col==3) player[current].setColor(g,Color.green);
	  
	}
	
	board[board_to].which_players+=player[current].col;
	// subtract players from board_from
	player[current].location = board_to;			
	boolean flag = false;
	do {
	  playert ++;
	  if (playert > Number_of_players) playert = 0;
	  send(PLAYER_SEND);//agent.send(stringToBytes( String.valueOf(PLAYER_SEND)));
	  send(playert);//agent.send(stringToBytes( String.valueOf(playert)));
	  if (board_toa < 100){
	    die = 1 + (int) ( Math.random() * 6 );
	    send(DIE_SEND);//agent.send(stringToBytes( String.valueOf(DIE_SEND)));
	    send(die);//agent.send(stringToBytes( String.valueOf(die)));
	  }
	  Die.Number(g, die,playert);
	  Die.paint(g);
	  
	  if ((find_boardto(player[playert].location)+die)>100 && Number_of_players>0
	      && board_toa != 100 ) {
	    flag = false;
	  }else {
	    flag = true;
	  }
	}while(flag == false);
	
      } else {								
	player[current].setColor(g,Color.cyan);
	player[current].x = oldx;
	player[current].y = oldy;
	if (player[current].col == 0) {
	  player[current].setColor(g,Color.blue);
	} else if (player[current].col == 1) {
	  player[current].setColor(g,Color.red);
	} else if (player[current].col == 2) {		
	  player[current].setColor(g,Color.black);
	} else if (player[current].col == 3) {		
	  player[current].setColor(g,Color.green);
	}			 
      }
    }						
    
    if (board_toa == 100){
      //(find_boardto(player[current].location) == 100) {
      //System.out.println("Player won: "+current);
      g.setFont(f);						
      if (current == 0) {
	g.setColor(Color.blue);
	g.drawString("Blue has just won!",100,30);
	//System.out.println("Blue has just won");
      } else if (current == 1) {
	g.setColor(Color.red);
	g.drawString("Red has just won!",100,30);
	//System.out.println("Red has just won");
      } else if (current == 2) {
	g.setColor(Color.black);
	g.drawString("Black has just won!",100,30);
	//System.out.println("Black has just won");
      } else if (current == 3) {
	g.setColor(Color.green);
	g.drawString("Green has just won!",100,30);
	//System.out.println("Green has just won");
      }
      win = true;		
      player_won = current;					
      send(WIN_SEND);//agent.send(stringToBytes( String.valueOf(WIN_SEND)));
      send(current);//agent.send(stringToBytes( String.valueOf(current)));
      repaint();
    }
    g.dispose();
    
    current = -1;
    
    return true;
  }
  
  /* Mouse Enter Event */
  public boolean mouseEnter(Event ev, int x, int y) {
    setForeground(Color.black);
    drawBoundry();
    return true;
  }
  /* Mouse Exit Event */
  public boolean mouseExit(Event ev, int x, int y) {
    
    setForeground(Color.black);
    drawBoundry();
    return true;
  }	
  
  public void destroy()
    {
      //if(agent!=null)
	//agent.exit();
	super.destroy();
    }
  
  public void masterChanged(boolean isMaster,String masterName){
    System.out.println("isMaster: "+ isMaster);
    System.out.println("masterName: " + masterName);
  }
  public void participantJoined(String participantName){
    System.out.println("participantJoined: "+ participantName);
  }
  public void participantLeft(String participantName){
    System.out.println("participantLeft: "+ participantName);
  }
  public void audioRequested(boolean isRequested){}
  
}
